/*
 * File: heading_control.c
 *
 * Code generated for Simulink model 'heading_control'.
 *
 * Model version                  : 1.153
 * Simulink Coder version         : 8.1 (R2011b) 08-Jul-2011
 * TLC version                    : 8.1 (Jul  9 2011)
 * C/C++ source code generated on : Fri Mar 01 16:24:21 2013
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: Generic->32-bit x86 compatible
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "heading_control.h"
#include "heading_control_private.h"

/* user code (top of source file) */
#include "../../../Software/FlightCode/control/rtw_grt_control.c"

/* Block signals (auto storage) */
BlockIO_heading_control heading_control_B;

/* Block states (auto storage) */
D_Work_heading_control heading_control_DWork;

/* External inputs (root inport signals with auto storage) */
ExternalInputs_heading_control heading_control_U;

/* External outputs (root outports fed by signals with auto storage) */
ExternalOutputs_heading_control heading_control_Y;

/* Real-time model */
RT_MODEL_heading_control heading_control_M_;
RT_MODEL_heading_control *const heading_control_M = &heading_control_M_;

/* Model step function */
void heading_control_step(void)
{
  real_T denAccum;
  real_T u;
  real_T u_0;

  /* DiscreteIntegrator: '<S3>/Discrete-Time Integrator' */
  heading_control_B.DiscreteTimeIntegrator =
    heading_control_DWork.DiscreteTimeIntegrator_DSTATE;

  /* Gain: '<S3>/Gain1' */
  heading_control_B.Gain1 = 0.04 * heading_control_B.DiscreteTimeIntegrator;

  /* DiscreteTransferFcn: '<S3>/Discrete Transfer Fcn' */
  denAccum = 0.0392 * heading_control_DWork.DiscreteTransferFcn_DSTATE;
  heading_control_B.DiscreteTransferFcn = denAccum;

  /* Sum: '<S3>/Sum5' incorporates:
   *  Constant: '<S3>/    '
   */
  heading_control_B.Sum5 = heading_control_B.DiscreteTransferFcn - 0.0;

  /* Sum: '<S3>/Sum1' incorporates:
   *  Inport: '<Root>/ref_cmds'
   */
  heading_control_B.Sum1 = heading_control_U.ref_cmds[1] -
    heading_control_B.Sum5;

  /* Gain: '<S3>/Gain' */
  heading_control_B.Gain = 0.15 * heading_control_B.Sum1;

  /* Sum: '<S3>/Sum' */
  heading_control_B.Sum = heading_control_B.Gain1 + heading_control_B.Gain;

  /* Saturate: '<S3>/Saturation1' */
  denAccum = heading_control_B.Sum;
  u = 0.0;
  u_0 = 1.0;
  heading_control_B.Saturation1 = denAccum >= u_0 ? u_0 : denAccum <= u ? u :
    denAccum;

  /* DiscreteIntegrator: '<S31>/Discrete-Time Integrator' */
  heading_control_B.DiscreteTimeIntegrator_f =
    heading_control_DWork.DiscreteTimeIntegrator_DSTATE_d;

  /* Gain: '<S31>/Gain1' */
  heading_control_B.Gain1_j = (-0.3) *
    heading_control_B.DiscreteTimeIntegrator_f;

  /* DiscreteIntegrator: '<S5>/Discrete-Time Integrator' */
  heading_control_B.DiscreteTimeIntegrator_l =
    heading_control_DWork.DiscreteTimeIntegrator_DSTATE_n;

  /* Gain: '<S5>/Gain1' */
  heading_control_B.Gain1_o = 0.001 * heading_control_B.DiscreteTimeIntegrator_l;

  /* DiscreteTransferFcn: '<S1>/Discrete Transfer Fcn' */
  denAccum = 0.0392 * heading_control_DWork.DiscreteTransferFcn_DSTATE_a;
  heading_control_B.DiscreteTransferFcn_n = denAccum;

  /* Sum: '<S1>/Sum5' incorporates:
   *  Constant: '<S1>/trim altitude'
   */
  heading_control_B.Sum5_m = heading_control_B.DiscreteTransferFcn_n - 0.0;

  /* Sum: '<S1>/Sum4' incorporates:
   *  Inport: '<Root>/ref_cmds'
   */
  heading_control_B.Sum4 = heading_control_U.ref_cmds[2] -
    heading_control_B.Sum5_m;

  /* Gain: '<S5>/Gain' */
  heading_control_B.Gain_m = 0.023 * heading_control_B.Sum4;

  /* Sum: '<S5>/Sum' */
  heading_control_B.Sum_f = heading_control_B.Gain1_o + heading_control_B.Gain_m;

  /* Saturate: '<S1>/Saturation' */
  denAccum = heading_control_B.Sum_f;
  u = (-0.3490658503988659);
  u_0 = 0.3490658503988659;
  heading_control_B.Saturation = denAccum >= u_0 ? u_0 : denAccum <= u ? u :
    denAccum;

  /* Sum: '<S21>/Sum1' incorporates:
   *  Constant: '<S21>/ Theta Trim'
   *  Inport: '<Root>/feedback'
   */
  heading_control_B.Sum1_g = heading_control_U.feedback[3] - 0.0;

  /* Sum: '<S21>/Sum2' */
  heading_control_B.Sum2 = heading_control_B.Saturation -
    heading_control_B.Sum1_g;

  /* Gain: '<S31>/Gain' */
  heading_control_B.Gain_l = (-0.9) * heading_control_B.Sum2;

  /* Sum: '<S31>/Sum' */
  heading_control_B.Sum_c = heading_control_B.Gain1_j + heading_control_B.Gain_l;

  /* Gain: '<S21>/Gain1' incorporates:
   *  Inport: '<Root>/feedback'
   */
  heading_control_B.Gain1_p = (-0.08) * heading_control_U.feedback[6];

  /* Sum: '<S21>/Sum' */
  heading_control_B.Sum_g = heading_control_B.Sum_c - heading_control_B.Gain1_p;

  /* Saturate: '<S21>/Saturation1' */
  denAccum = heading_control_B.Sum_g;
  u = (-0.43633231299858238);
  u_0 = 0.43633231299858238;
  heading_control_B.Saturation1_g = denAccum >= u_0 ? u_0 : denAccum <= u ? u :
    denAccum;

  /* DiscreteTransferFcn: '<S22>/Discrete Transfer Fcn' incorporates:
   *  Inport: '<Root>/feedback'
   */
  denAccum = heading_control_U.feedback[7];
  denAccum -= (-0.96078943915232329) *
    heading_control_DWork.DiscreteTransferFcn_DSTATE_e;
  denAccum /= 1.0;
  heading_control_DWork.DiscreteTransferFcn_tmp = denAccum;
  denAccum = 0.065 * heading_control_DWork.DiscreteTransferFcn_tmp;
  denAccum += (-0.065) * heading_control_DWork.DiscreteTransferFcn_DSTATE_e;
  heading_control_B.DiscreteTransferFcn_b = denAccum;

  /* DiscreteIntegrator: '<S23>/Discrete-Time Integrator' */
  heading_control_B.DiscreteTimeIntegrator_k =
    heading_control_DWork.DiscreteTimeIntegrator_DSTAT_ng;

  /* Gain: '<S23>/Gain1' */
  heading_control_B.Gain1_g = (-0.2) *
    heading_control_B.DiscreteTimeIntegrator_k;

  /* Sum: '<S2>/Sum2' incorporates:
   *  Constant: '<S2>/psi trim'
   *  Inport: '<Root>/feedback'
   */
  heading_control_B.Sum2_c = heading_control_U.feedback[4] - 0.0;

  /* Sum: '<S2>/Sum1' incorporates:
   *  Inport: '<Root>/ref_cmds'
   */
  heading_control_B.Sum1_d = heading_control_U.ref_cmds[0] -
    heading_control_B.Sum2_c;

  /* Gain: '<S2>/Gain5' */
  heading_control_B.Gain5 = 1.5 * heading_control_B.Sum1_d;

  /* Saturate: '<S2>/Saturation1' */
  denAccum = heading_control_B.Gain5;
  u = (-0.78539816339744828);
  u_0 = 0.78539816339744828;
  heading_control_B.Saturation1_i = denAccum >= u_0 ? u_0 : denAccum <= u ? u :
    denAccum;

  /* Sum: '<S20>/Sum5' incorporates:
   *  Constant: '<S20>/Phi Trim'
   *  Inport: '<Root>/feedback'
   */
  heading_control_B.Sum5_f = heading_control_U.feedback[2] - 0.0;

  /* Sum: '<S20>/Sum2' */
  heading_control_B.Sum2_l = heading_control_B.Saturation1_i -
    heading_control_B.Sum5_f;

  /* Gain: '<S23>/Gain' */
  heading_control_B.Gain_lv = (-0.64) * heading_control_B.Sum2_l;

  /* Sum: '<S23>/Sum' */
  heading_control_B.Sum_j = heading_control_B.Gain1_g +
    heading_control_B.Gain_lv;

  /* Gain: '<S20>/Gain1' incorporates:
   *  Inport: '<Root>/feedback'
   */
  heading_control_B.Gain1_b = (-0.07) * heading_control_U.feedback[5];

  /* Sum: '<S20>/Sum3' */
  heading_control_B.Sum3 = heading_control_B.Sum_j - heading_control_B.Gain1_b;

  /* Saturate: '<S20>/Saturation1' */
  denAccum = heading_control_B.Sum3;
  u = (-0.43633231299858238);
  u_0 = 0.43633231299858238;
  heading_control_B.Saturation1_p = denAccum >= u_0 ? u_0 : denAccum <= u ? u :
    denAccum;

  /* Gain: '<Root>/Gain' */
  heading_control_B.Gain_d = (-1.0) * heading_control_B.Saturation1_p;

  /* Outport: '<Root>/control_cmd' incorporates:
   *  Constant: '<Root>/flaps'
   */
  heading_control_Y.control_cmd[0] = heading_control_B.Saturation1;
  heading_control_Y.control_cmd[1] = heading_control_B.Saturation1_g;
  heading_control_Y.control_cmd[2] = heading_control_B.DiscreteTransferFcn_b;
  heading_control_Y.control_cmd[3] = heading_control_B.Gain_d;
  heading_control_Y.control_cmd[4] = heading_control_B.Saturation1_p;
  heading_control_Y.control_cmd[5] = 0.0;
  heading_control_Y.control_cmd[6] = 0.0;
  heading_control_Y.control_cmd[7] = 0.0;

  /* RelationalOperator: '<S7>/Compare' incorporates:
   *  Constant: '<S7>/Constant'
   */
  heading_control_B.Compare = (heading_control_B.Sum4 < 0.0);

  /* RelationalOperator: '<S8>/Compare' incorporates:
   *  Constant: '<S8>/Constant'
   */
  heading_control_B.Compare_i = (heading_control_B.Sum4 > 0.0);

  /* RelationalOperator: '<S9>/Compare' incorporates:
   *  Constant: '<S9>/Constant'
   */
  heading_control_B.Compare_o = (heading_control_B.Sum4 > 0.0);

  /* RelationalOperator: '<S10>/Compare' incorporates:
   *  Constant: '<S10>/Constant'
   */
  heading_control_B.Compare_k = (heading_control_B.Sum4 < 0.0);

  /* RelationalOperator: '<S11>/Lower Test' incorporates:
   *  Constant: '<S6>/min deflection limit'
   */
  heading_control_B.LowerTest = ((-0.43633231299858238) <=
    heading_control_B.Sum_f);

  /* RelationalOperator: '<S11>/Upper Test' incorporates:
   *  Constant: '<S6>/max deflection limit'
   */
  heading_control_B.UpperTest = (heading_control_B.Sum_f <= 0.43633231299858238);

  /* Logic: '<S11>/FixPt Logical Operator' */
  heading_control_B.FixPtLogicalOperator = (heading_control_B.LowerTest &&
    heading_control_B.UpperTest);

  /* RelationalOperator: '<S6>/Relational Operator' incorporates:
   *  Constant: '<S6>/max deflection limit'
   */
  heading_control_B.RelationalOperator = (heading_control_B.Sum_f >=
    0.43633231299858238);

  /* Logic: '<S6>/Logical Operator' */
  heading_control_B.LogicalOperator = (heading_control_B.RelationalOperator &&
    (heading_control_B.Compare != 0));

  /* RelationalOperator: '<S6>/Relational Operator2' incorporates:
   *  Constant: '<S6>/max deflection limit '
   */
  heading_control_B.RelationalOperator2 = (heading_control_B.Sum_f >=
    0.43633231299858238);

  /* Logic: '<S6>/Logical Operator4' */
  heading_control_B.LogicalOperator4 = (heading_control_B.RelationalOperator2 &&
                                        (heading_control_B.Compare_o != 0));

  /* Switch: '<S6>/Switch4' incorporates:
   *  Constant: '<S6>/min deflection limit1'
   */
  if (1.0 != 0.0) {
    heading_control_B.Switch4 = heading_control_B.LogicalOperator;
  } else {
    heading_control_B.Switch4 = heading_control_B.LogicalOperator4;
  }

  /* End of Switch: '<S6>/Switch4' */

  /* RelationalOperator: '<S6>/Relational Operator1' incorporates:
   *  Constant: '<S6>/min deflection limit'
   */
  heading_control_B.RelationalOperator1 = (heading_control_B.Sum_f <=
    (-0.43633231299858238));

  /* Logic: '<S6>/Logical Operator2' */
  heading_control_B.LogicalOperator2 = (heading_control_B.RelationalOperator1 &&
                                        (heading_control_B.Compare_i != 0));

  /* RelationalOperator: '<S6>/Relational Operator3' incorporates:
   *  Constant: '<S6>/min deflection limit '
   */
  heading_control_B.RelationalOperator3 = (heading_control_B.Sum_f <=
    (-0.43633231299858238));

  /* Logic: '<S6>/Logical Operator6' */
  heading_control_B.LogicalOperator6 = (heading_control_B.RelationalOperator3 &&
                                        (heading_control_B.Compare_k != 0));

  /* Switch: '<S6>/Switch1' incorporates:
   *  Constant: '<S6>/min deflection limit2'
   */
  if (1.0 != 0.0) {
    heading_control_B.Switch1 = heading_control_B.LogicalOperator2;
  } else {
    heading_control_B.Switch1 = heading_control_B.LogicalOperator6;
  }

  /* End of Switch: '<S6>/Switch1' */

  /* Logic: '<S6>/Logical Operator1' */
  heading_control_B.LogicalOperator1 = (heading_control_B.Switch4 ||
    heading_control_B.Switch1);

  /* Switch: '<S6>/Switch2' incorporates:
   *  Constant: '<S6>/min deflection limit3'
   */
  if (1.0 != 0.0) {
    heading_control_B.Switch2 = heading_control_B.LogicalOperator4;
  } else {
    heading_control_B.Switch2 = heading_control_B.LogicalOperator;
  }

  /* End of Switch: '<S6>/Switch2' */

  /* Switch: '<S6>/Switch3' incorporates:
   *  Constant: '<S6>/min deflection limit4'
   */
  if (1.0 != 0.0) {
    heading_control_B.Switch3 = heading_control_B.LogicalOperator6;
  } else {
    heading_control_B.Switch3 = heading_control_B.LogicalOperator2;
  }

  /* End of Switch: '<S6>/Switch3' */

  /* Logic: '<S6>/Logical Operator5' */
  heading_control_B.LogicalOperator5 = (heading_control_B.Switch2 &&
    heading_control_B.Switch3);

  /* Logic: '<S6>/Logical Operator3' */
  heading_control_B.LogicalOperator3 = (heading_control_B.FixPtLogicalOperator ||
    heading_control_B.LogicalOperator1 || heading_control_B.LogicalOperator5);

  /* Product: '<S6>/Product' */
  heading_control_B.Product = (real_T)heading_control_B.LogicalOperator3 *
    heading_control_B.Sum4;

  /* RelationalOperator: '<S14>/Compare' incorporates:
   *  Constant: '<S14>/Constant'
   */
  heading_control_B.Compare_o1 = (heading_control_B.Sum1 < 0.0);

  /* RelationalOperator: '<S15>/Compare' incorporates:
   *  Constant: '<S15>/Constant'
   */
  heading_control_B.Compare_a = (heading_control_B.Sum1 > 0.0);

  /* RelationalOperator: '<S16>/Compare' incorporates:
   *  Constant: '<S16>/Constant'
   */
  heading_control_B.Compare_m = (heading_control_B.Sum1 > 0.0);

  /* RelationalOperator: '<S17>/Compare' incorporates:
   *  Constant: '<S17>/Constant'
   */
  heading_control_B.Compare_c = (heading_control_B.Sum1 < 0.0);

  /* RelationalOperator: '<S18>/Lower Test' incorporates:
   *  Constant: '<S13>/min deflection limit'
   */
  heading_control_B.LowerTest_f = ((-0.43633231299858238) <=
    heading_control_B.Sum);

  /* RelationalOperator: '<S18>/Upper Test' incorporates:
   *  Constant: '<S13>/max deflection limit'
   */
  heading_control_B.UpperTest_g = (heading_control_B.Sum <= 0.43633231299858238);

  /* Logic: '<S18>/FixPt Logical Operator' */
  heading_control_B.FixPtLogicalOperator_d = (heading_control_B.LowerTest_f &&
    heading_control_B.UpperTest_g);

  /* RelationalOperator: '<S13>/Relational Operator' incorporates:
   *  Constant: '<S13>/max deflection limit'
   */
  heading_control_B.RelationalOperator_l = (heading_control_B.Sum >=
    0.43633231299858238);

  /* Logic: '<S13>/Logical Operator' */
  heading_control_B.LogicalOperator_l = (heading_control_B.RelationalOperator_l &&
    (heading_control_B.Compare_o1 != 0));

  /* RelationalOperator: '<S13>/Relational Operator2' incorporates:
   *  Constant: '<S13>/max deflection limit '
   */
  heading_control_B.RelationalOperator2_h = (heading_control_B.Sum >=
    0.43633231299858238);

  /* Logic: '<S13>/Logical Operator4' */
  heading_control_B.LogicalOperator4_k =
    (heading_control_B.RelationalOperator2_h && (heading_control_B.Compare_m !=
      0));

  /* Switch: '<S13>/Switch4' incorporates:
   *  Constant: '<S13>/min deflection limit1'
   */
  if (1.0 != 0.0) {
    heading_control_B.Switch4_j = heading_control_B.LogicalOperator_l;
  } else {
    heading_control_B.Switch4_j = heading_control_B.LogicalOperator4_k;
  }

  /* End of Switch: '<S13>/Switch4' */

  /* RelationalOperator: '<S13>/Relational Operator1' incorporates:
   *  Constant: '<S13>/min deflection limit'
   */
  heading_control_B.RelationalOperator1_p = (heading_control_B.Sum <=
    (-0.43633231299858238));

  /* Logic: '<S13>/Logical Operator2' */
  heading_control_B.LogicalOperator2_e =
    (heading_control_B.RelationalOperator1_p && (heading_control_B.Compare_a !=
      0));

  /* RelationalOperator: '<S13>/Relational Operator3' incorporates:
   *  Constant: '<S13>/min deflection limit '
   */
  heading_control_B.RelationalOperator3_k = (heading_control_B.Sum <=
    (-0.43633231299858238));

  /* Logic: '<S13>/Logical Operator6' */
  heading_control_B.LogicalOperator6_d =
    (heading_control_B.RelationalOperator3_k && (heading_control_B.Compare_c !=
      0));

  /* Switch: '<S13>/Switch1' incorporates:
   *  Constant: '<S13>/min deflection limit2'
   */
  if (1.0 != 0.0) {
    heading_control_B.Switch1_j = heading_control_B.LogicalOperator2_e;
  } else {
    heading_control_B.Switch1_j = heading_control_B.LogicalOperator6_d;
  }

  /* End of Switch: '<S13>/Switch1' */

  /* Logic: '<S13>/Logical Operator1' */
  heading_control_B.LogicalOperator1_g = (heading_control_B.Switch4_j ||
    heading_control_B.Switch1_j);

  /* Switch: '<S13>/Switch2' incorporates:
   *  Constant: '<S13>/min deflection limit3'
   */
  if (1.0 != 0.0) {
    heading_control_B.Switch2_h = heading_control_B.LogicalOperator4_k;
  } else {
    heading_control_B.Switch2_h = heading_control_B.LogicalOperator_l;
  }

  /* End of Switch: '<S13>/Switch2' */

  /* Switch: '<S13>/Switch3' incorporates:
   *  Constant: '<S13>/min deflection limit4'
   */
  if (1.0 != 0.0) {
    heading_control_B.Switch3_g = heading_control_B.LogicalOperator6_d;
  } else {
    heading_control_B.Switch3_g = heading_control_B.LogicalOperator2_e;
  }

  /* End of Switch: '<S13>/Switch3' */

  /* Logic: '<S13>/Logical Operator5' */
  heading_control_B.LogicalOperator5_e = (heading_control_B.Switch2_h &&
    heading_control_B.Switch3_g);

  /* Logic: '<S13>/Logical Operator3' */
  heading_control_B.LogicalOperator3_h =
    (heading_control_B.FixPtLogicalOperator_d ||
     heading_control_B.LogicalOperator1_g ||
     heading_control_B.LogicalOperator5_e);

  /* Product: '<S13>/Product' */
  heading_control_B.Product_o = (real_T)heading_control_B.LogicalOperator3_h *
    heading_control_B.Sum1;

  /* RelationalOperator: '<S33>/Compare' incorporates:
   *  Constant: '<S33>/Constant'
   */
  heading_control_B.Compare_g = (heading_control_B.Sum2 < 0.0);

  /* RelationalOperator: '<S34>/Compare' incorporates:
   *  Constant: '<S34>/Constant'
   */
  heading_control_B.Compare_ar = (heading_control_B.Sum2 > 0.0);

  /* RelationalOperator: '<S35>/Compare' incorporates:
   *  Constant: '<S35>/Constant'
   */
  heading_control_B.Compare_ml = (heading_control_B.Sum2 > 0.0);

  /* RelationalOperator: '<S36>/Compare' incorporates:
   *  Constant: '<S36>/Constant'
   */
  heading_control_B.Compare_oa = (heading_control_B.Sum2 < 0.0);

  /* RelationalOperator: '<S37>/Lower Test' incorporates:
   *  Constant: '<S32>/min deflection limit'
   */
  heading_control_B.LowerTest_e = ((-0.43633231299858238) <=
    heading_control_B.Sum_g);

  /* RelationalOperator: '<S37>/Upper Test' incorporates:
   *  Constant: '<S32>/max deflection limit'
   */
  heading_control_B.UpperTest_a = (heading_control_B.Sum_g <=
    0.43633231299858238);

  /* Logic: '<S37>/FixPt Logical Operator' */
  heading_control_B.FixPtLogicalOperator_n = (heading_control_B.LowerTest_e &&
    heading_control_B.UpperTest_a);

  /* RelationalOperator: '<S32>/Relational Operator' incorporates:
   *  Constant: '<S32>/max deflection limit'
   */
  heading_control_B.RelationalOperator_p = (heading_control_B.Sum_g >=
    0.43633231299858238);

  /* Logic: '<S32>/Logical Operator' */
  heading_control_B.LogicalOperator_n = (heading_control_B.RelationalOperator_p &&
    (heading_control_B.Compare_g != 0));

  /* RelationalOperator: '<S32>/Relational Operator2' incorporates:
   *  Constant: '<S32>/max deflection limit '
   */
  heading_control_B.RelationalOperator2_n = (heading_control_B.Sum_g >=
    0.43633231299858238);

  /* Logic: '<S32>/Logical Operator4' */
  heading_control_B.LogicalOperator4_e =
    (heading_control_B.RelationalOperator2_n && (heading_control_B.Compare_ml !=
      0));

  /* Switch: '<S32>/Switch4' incorporates:
   *  Constant: '<S32>/min deflection limit1'
   */
  if (0.0 != 0.0) {
    heading_control_B.Switch4_k = heading_control_B.LogicalOperator_n;
  } else {
    heading_control_B.Switch4_k = heading_control_B.LogicalOperator4_e;
  }

  /* End of Switch: '<S32>/Switch4' */

  /* RelationalOperator: '<S32>/Relational Operator1' incorporates:
   *  Constant: '<S32>/min deflection limit'
   */
  heading_control_B.RelationalOperator1_h = (heading_control_B.Sum_g <=
    (-0.43633231299858238));

  /* Logic: '<S32>/Logical Operator2' */
  heading_control_B.LogicalOperator2_f =
    (heading_control_B.RelationalOperator1_h && (heading_control_B.Compare_ar !=
      0));

  /* RelationalOperator: '<S32>/Relational Operator3' incorporates:
   *  Constant: '<S32>/min deflection limit '
   */
  heading_control_B.RelationalOperator3_a = (heading_control_B.Sum_g <=
    (-0.43633231299858238));

  /* Logic: '<S32>/Logical Operator6' */
  heading_control_B.LogicalOperator6_k =
    (heading_control_B.RelationalOperator3_a && (heading_control_B.Compare_oa !=
      0));

  /* Switch: '<S32>/Switch1' incorporates:
   *  Constant: '<S32>/min deflection limit2'
   */
  if (0.0 != 0.0) {
    heading_control_B.Switch1_jr = heading_control_B.LogicalOperator2_f;
  } else {
    heading_control_B.Switch1_jr = heading_control_B.LogicalOperator6_k;
  }

  /* End of Switch: '<S32>/Switch1' */

  /* Logic: '<S32>/Logical Operator1' */
  heading_control_B.LogicalOperator1_f = (heading_control_B.Switch4_k ||
    heading_control_B.Switch1_jr);

  /* Switch: '<S32>/Switch2' incorporates:
   *  Constant: '<S32>/min deflection limit3'
   */
  if (0.0 != 0.0) {
    heading_control_B.Switch2_l = heading_control_B.LogicalOperator4_e;
  } else {
    heading_control_B.Switch2_l = heading_control_B.LogicalOperator_n;
  }

  /* End of Switch: '<S32>/Switch2' */

  /* Switch: '<S32>/Switch3' incorporates:
   *  Constant: '<S32>/min deflection limit4'
   */
  if (0.0 != 0.0) {
    heading_control_B.Switch3_b = heading_control_B.LogicalOperator6_k;
  } else {
    heading_control_B.Switch3_b = heading_control_B.LogicalOperator2_f;
  }

  /* End of Switch: '<S32>/Switch3' */

  /* Logic: '<S32>/Logical Operator5' */
  heading_control_B.LogicalOperator5_f = (heading_control_B.Switch2_l &&
    heading_control_B.Switch3_b);

  /* Logic: '<S32>/Logical Operator3' */
  heading_control_B.LogicalOperator3_o =
    (heading_control_B.FixPtLogicalOperator_n ||
     heading_control_B.LogicalOperator1_f ||
     heading_control_B.LogicalOperator5_f);

  /* Product: '<S32>/Product' */
  heading_control_B.Product_p = (real_T)heading_control_B.LogicalOperator3_o *
    heading_control_B.Sum2;

  /* RelationalOperator: '<S25>/Compare' incorporates:
   *  Constant: '<S25>/Constant'
   */
  heading_control_B.Compare_ab = (heading_control_B.Sum2_l < 0.0);

  /* RelationalOperator: '<S26>/Compare' incorporates:
   *  Constant: '<S26>/Constant'
   */
  heading_control_B.Compare_n = (heading_control_B.Sum2_l > 0.0);

  /* RelationalOperator: '<S27>/Compare' incorporates:
   *  Constant: '<S27>/Constant'
   */
  heading_control_B.Compare_c4 = (heading_control_B.Sum2_l > 0.0);

  /* RelationalOperator: '<S28>/Compare' incorporates:
   *  Constant: '<S28>/Constant'
   */
  heading_control_B.Compare_h = (heading_control_B.Sum2_l < 0.0);

  /* RelationalOperator: '<S29>/Lower Test' incorporates:
   *  Constant: '<S24>/min deflection limit'
   */
  heading_control_B.LowerTest_f3 = ((-0.43633231299858238) <=
    heading_control_B.Sum3);

  /* RelationalOperator: '<S29>/Upper Test' incorporates:
   *  Constant: '<S24>/max deflection limit'
   */
  heading_control_B.UpperTest_k = (heading_control_B.Sum3 <= 0.43633231299858238);

  /* Logic: '<S29>/FixPt Logical Operator' */
  heading_control_B.FixPtLogicalOperator_k = (heading_control_B.LowerTest_f3 &&
    heading_control_B.UpperTest_k);

  /* RelationalOperator: '<S24>/Relational Operator' incorporates:
   *  Constant: '<S24>/max deflection limit'
   */
  heading_control_B.RelationalOperator_n = (heading_control_B.Sum3 >=
    0.43633231299858238);

  /* Logic: '<S24>/Logical Operator' */
  heading_control_B.LogicalOperator_h = (heading_control_B.RelationalOperator_n &&
    (heading_control_B.Compare_ab != 0));

  /* RelationalOperator: '<S24>/Relational Operator2' incorporates:
   *  Constant: '<S24>/max deflection limit '
   */
  heading_control_B.RelationalOperator2_m = (heading_control_B.Sum3 >=
    0.43633231299858238);

  /* Logic: '<S24>/Logical Operator4' */
  heading_control_B.LogicalOperator4_m =
    (heading_control_B.RelationalOperator2_m && (heading_control_B.Compare_c4 !=
      0));

  /* Switch: '<S24>/Switch4' incorporates:
   *  Constant: '<S24>/min deflection limit1'
   */
  if (0.0 != 0.0) {
    heading_control_B.Switch4_d = heading_control_B.LogicalOperator_h;
  } else {
    heading_control_B.Switch4_d = heading_control_B.LogicalOperator4_m;
  }

  /* End of Switch: '<S24>/Switch4' */

  /* RelationalOperator: '<S24>/Relational Operator1' incorporates:
   *  Constant: '<S24>/min deflection limit'
   */
  heading_control_B.RelationalOperator1_m = (heading_control_B.Sum3 <=
    (-0.43633231299858238));

  /* Logic: '<S24>/Logical Operator2' */
  heading_control_B.LogicalOperator2_k =
    (heading_control_B.RelationalOperator1_m && (heading_control_B.Compare_n !=
      0));

  /* RelationalOperator: '<S24>/Relational Operator3' incorporates:
   *  Constant: '<S24>/min deflection limit '
   */
  heading_control_B.RelationalOperator3_f = (heading_control_B.Sum3 <=
    (-0.43633231299858238));

  /* Logic: '<S24>/Logical Operator6' */
  heading_control_B.LogicalOperator6_j =
    (heading_control_B.RelationalOperator3_f && (heading_control_B.Compare_h !=
      0));

  /* Switch: '<S24>/Switch1' incorporates:
   *  Constant: '<S24>/min deflection limit2'
   */
  if (0.0 != 0.0) {
    heading_control_B.Switch1_n = heading_control_B.LogicalOperator2_k;
  } else {
    heading_control_B.Switch1_n = heading_control_B.LogicalOperator6_j;
  }

  /* End of Switch: '<S24>/Switch1' */

  /* Logic: '<S24>/Logical Operator1' */
  heading_control_B.LogicalOperator1_i = (heading_control_B.Switch4_d ||
    heading_control_B.Switch1_n);

  /* Switch: '<S24>/Switch2' incorporates:
   *  Constant: '<S24>/min deflection limit3'
   */
  if (0.0 != 0.0) {
    heading_control_B.Switch2_b = heading_control_B.LogicalOperator4_m;
  } else {
    heading_control_B.Switch2_b = heading_control_B.LogicalOperator_h;
  }

  /* End of Switch: '<S24>/Switch2' */

  /* Switch: '<S24>/Switch3' incorporates:
   *  Constant: '<S24>/min deflection limit4'
   */
  if (0.0 != 0.0) {
    heading_control_B.Switch3_k = heading_control_B.LogicalOperator6_j;
  } else {
    heading_control_B.Switch3_k = heading_control_B.LogicalOperator2_k;
  }

  /* End of Switch: '<S24>/Switch3' */

  /* Logic: '<S24>/Logical Operator5' */
  heading_control_B.LogicalOperator5_i = (heading_control_B.Switch2_b &&
    heading_control_B.Switch3_k);

  /* Logic: '<S24>/Logical Operator3' */
  heading_control_B.LogicalOperator3_g =
    (heading_control_B.FixPtLogicalOperator_k ||
     heading_control_B.LogicalOperator1_i ||
     heading_control_B.LogicalOperator5_i);

  /* Product: '<S24>/Product' */
  heading_control_B.Product_g = (real_T)heading_control_B.LogicalOperator3_g *
    heading_control_B.Sum2_l;

  /* Update for DiscreteIntegrator: '<S3>/Discrete-Time Integrator' */
  heading_control_DWork.DiscreteTimeIntegrator_DSTATE = 0.02 *
    heading_control_B.Product_o +
    heading_control_DWork.DiscreteTimeIntegrator_DSTATE;

  /* Update for DiscreteTransferFcn: '<S3>/Discrete Transfer Fcn' incorporates:
   *  Inport: '<Root>/feedback'
   */
  denAccum = heading_control_U.feedback[0];
  denAccum -= (-0.9608) * heading_control_DWork.DiscreteTransferFcn_DSTATE;
  denAccum /= 1.0;
  heading_control_DWork.DiscreteTransferFcn_DSTATE = denAccum;

  /* Update for DiscreteIntegrator: '<S31>/Discrete-Time Integrator' */
  heading_control_DWork.DiscreteTimeIntegrator_DSTATE_d = 0.02 *
    heading_control_B.Product_p +
    heading_control_DWork.DiscreteTimeIntegrator_DSTATE_d;

  /* Update for DiscreteIntegrator: '<S5>/Discrete-Time Integrator' */
  heading_control_DWork.DiscreteTimeIntegrator_DSTATE_n = 0.02 *
    heading_control_B.Product +
    heading_control_DWork.DiscreteTimeIntegrator_DSTATE_n;

  /* Update for DiscreteTransferFcn: '<S1>/Discrete Transfer Fcn' incorporates:
   *  Inport: '<Root>/feedback'
   */
  denAccum = heading_control_U.feedback[1];
  denAccum -= (-0.9608) * heading_control_DWork.DiscreteTransferFcn_DSTATE_a;
  denAccum /= 1.0;
  heading_control_DWork.DiscreteTransferFcn_DSTATE_a = denAccum;

  /* Update for DiscreteTransferFcn: '<S22>/Discrete Transfer Fcn' */
  heading_control_DWork.DiscreteTransferFcn_DSTATE_e =
    heading_control_DWork.DiscreteTransferFcn_tmp;

  /* Update for DiscreteIntegrator: '<S23>/Discrete-Time Integrator' */
  heading_control_DWork.DiscreteTimeIntegrator_DSTAT_ng = 0.02 *
    heading_control_B.Product_g +
    heading_control_DWork.DiscreteTimeIntegrator_DSTAT_ng;
}

/* Model initialize function */
void heading_control_initialize(void)
{
  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));
}

/* Model terminate function */
void heading_control_terminate(void)
{
  /* (no terminate code required) */
}

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
