(defmethod subst-mod-params* ((type type-name) modinst bindings)
  (let* ((res (car (resolutions type)))
	 (decl (declaration res))
	 (act (cdr (assq decl bindings)))
	 (lhsmatch (unless act
		     (assoc decl bindings
			    :test #'(lambda (d bd)
				      (and (mapping-lhs? bd) (eq d (declaration bd))))))))
    #+pvsdebug (assert (or (null act) (fully-instantiated? (type-value act))))
    (cond (act
	   (type-value act) ;; sufficient since we know
	   ;; type name was found on the bindings, and the corresponding
	   ;; actual is there.  Here we actally do the substitution.
	   )
	  (lhsmatch
	   (let ((stype
		  (subst-for-formals
		   (type-value (cdr lhsmatch))
		   (mapcar #'(lambda (x y)
			       (cons x (type-value y)))
		     (decl-formals (car lhsmatch))
		     (dactuals type)))))
	     (subst-mod-params* stype modinst bindings)))
	  ;;((and nil *subst-mod-params-module?*
	  ;;	(eq (module decl) *subst-mod-params-module?*))
	  ;; type)
	  (t (or (mapped-theory-value (module decl) type modinst bindings)
		 (let* ((mi (module-instance res))
			(nacts (cond ((actuals mi)
				      (subst-mod-params*
				       (actuals mi) modinst bindings))
				     ((eq (id mi) (id modinst))
				      (actuals modinst))))
			(ndacts (cond ((dactuals mi)
				       (subst-mod-params*
					(dactuals mi) modinst bindings))
				      ((eq decl *subst-mod-params-declaration*)
				       (dactuals modinst)))))
		   #+pvsdebug (assert (not (and nacts
						(eq (id mi) (id modinst)))))
		   #+pvsdebug (assert (fully-instantiated? nacts))
		   (assert (or (mappings modinst)
			       (not (fully-instantiated? modinst))
			       (and (fully-instantiated? nacts)
				    (fully-instantiated? ndacts))))
		   (if (or nacts ndacts)
		       (if (and (eq (actuals mi) nacts)
				(eq (dactuals mi) ndacts))
			   type
			   ;; If modinst has a library, but mi does not, we
			   ;; may have to add a library to mi.  If (module
			   ;; decl) is a library theory, definitely need it,
			   ;; but how do we know it is the same library?
			   (let* ((lib
				   (when (and (library-datatype-or-theory?
					       (module decl))
					      (not (library-datatype-or-theory?
						    (current-theory))))
				     (car (rassoc (lib-ref (module decl))
						  (current-library-alist)
						  :test #'equal))))
				  (nmi (copy mi :actuals nacts
					     :dactuals ndacts
					     :library lib)))
			     #+pvsdebug
			     (assert (or lib
					 (not (library-datatype-or-theory?
					       (module decl)))
					 (from-prelude-library? decl)
					 (library-datatype-or-theory?
					  (current-theory))
					 (file-equal (lib-ref (module decl))
						     *pvs-context-path*)))
			     (subst-mod-params-type-name type nmi bindings modinst)))
		       (if (eq (id mi) (id modinst))
			   ;; mi is useless after this
			   (subst-mod-params-type-name type modinst bindings modinst)
			   type))))))))
